package com.changhong.epc.demo2.service;

import com.alibaba.fastjson.TypeReference;
import com.changhong.epc.bean.tenant.log.ProcessLog;
import com.changhong.epc.constter.system.SystemClients;
import com.changhong.epc.demo2.mapper.tenant.log.ProcessLogMapper;
import com.changhong.epc.rely.api.tool.HttpUtil;
import com.codingapi.tx.annotation.TxTransaction;
import com.codingapi.tx.aop.bean.TxTransactionLocal;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.ui.ModelMap;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;

@Service
public class DemoServiceImpl implements DemoService, SystemClients {

    @Resource
    private ProcessLogMapper processLogMapper;

    @Resource
    private RestTemplate restTemplate;

    @Override
    @TxTransaction(isStart = true)
    @Transactional
    public Object save() {
        ProcessLog t = new ProcessLog();
        t.setActivityInstId(2L);
        t.setActivityDefId("defId");
        t.setActivityDefName("defName");
        processLogMapper.insert(t);
        Map<String, Object> result = null;
//        SpringUtil
//                .getBean(SERVER_DEMO.getBeanName(), SimpleRestInterface.class)
//                .post("/save", new ModelMap(), Map.class);
//        restTemplate.exchange("http://localhost:9119/save", HttpMethod.POST, new HttpEntity<>(new ModelMap(), new HttpHeaders()), Map.class).getBody();
        try {
            Map<String, String> h = new HashMap<>();

            TxTransactionLocal txTransactionLocal = TxTransactionLocal.current();
            String groupId = txTransactionLocal == null ? null : txTransactionLocal.getGroupId();

            if(txTransactionLocal!=null) {
                h.put("tx-group", groupId);
            }
            result = HttpUtil.post("http://localhost:9119/save", h, new ModelMap(), new HashMap(), new TypeReference<Map<String, Object>>(){}.getType());
        } catch (Exception e) {
        }
        // System.out.println(result);
        return 1;
    }

    @Override
    @TxTransaction(isStart = true)
    @Transactional
    public Object save1() {
        ProcessLog t = new ProcessLog();
        t.setActivityInstId(2L);
        t.setActivityDefId("defId1");
        t.setActivityDefName("回滚");
        processLogMapper.insert(t);
        Map<String, Object> result = null;
//        SpringUtil
//                .getBean(SERVER_DEMO.getBeanName(), SimpleRestInterface.class)
//                .post("/save", new ModelMap(), Map.class);
//        restTemplate.exchange("http://localhost:9119/save", HttpMethod.POST, new HttpEntity<>(new ModelMap(), new HttpHeaders()), Map.class).getBody();
        try {
            Map<String, String> h = new HashMap<>();

            TxTransactionLocal txTransactionLocal = TxTransactionLocal.current();
            String groupId = txTransactionLocal == null ? null : txTransactionLocal.getGroupId();

            if(txTransactionLocal!=null) {
                h.put("tx-group", groupId);
            }
            result = HttpUtil.post("http://localhost:9119/save", h, new ModelMap(), new HashMap(), new TypeReference<Map<String, Object>>(){}.getType());
        } catch (Exception e) {
        }
        // System.out.println(result);
        throw new NullPointerException();
//        return 0;
    }
}
